package net
{
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.net.FileReference;
	
	import mx.graphics.codec.JPEGEncoder;
	import mx.controls.Alert;
	
	/**
	 * Class for saving a bitmapData from flash player to jpg-file on local computer.
	 * 
	 * Usage:
	 * new JpgFormatExporter(bitmapData, "defaultFileName.jpg");
	 * 
	 */ 
	public class JpgFormatExporter extends FileReference
	{
		
		private var 
			completedFunction:Function,
			canceledFunction:Function;
	
		public function JpgFormatExporter(
			bmd:BitmapData, 
			defaultFileName:String=null, 
			completed:Function=null, 
			canceled:Function=null)
		{
			super();
			this.completedFunction = completed;
			this.canceledFunction = canceled;
			
			this.addEventListener(Event.COMPLETE, fileSaveComplete);
			this.addEventListener(Event.CANCEL, fileSaveCanceled);
			
			var encoder:JPEGEncoder = new JPEGEncoder();
			if (bmd!=null) this.save(encoder.encode(bmd), defaultFileName);
			
		}
		
		private function fileSaveComplete(e:Event):void {
			mx.controls.Alert.show('Image File Exported!', 'Tiling', mx.controls.Alert.OK);
			if (this.completedFunction!=null) this.completedFunction(e);
		}
		
		private function fileSaveCanceled(e:Event):void {
			Alert.show('Export Canceled.', 'Tiling', mx.controls.Alert.OK);
			if (this.canceledFunction!=null) this.canceledFunction(e);
		}

		
		
		
		
	}
}